#ifndef _ABSTRACTLISTACTION_H_
#define _ABSTRACTLISTACTION_H_

#include "oaiaction.h"
#include "resumptiontoken.h"

class abstractlistaction : public oaiaction
{ 
 public:
  abstractlistaction(const text_t &name) : oaiaction(name) {this->prevDocSeen = false;}
  virtual bool validateAction(recptproto *protocol, oaiargs &params, int &numArgs); // Check that this is a valid action
  virtual bool output_document(ostream &output, recptproto *protocol, const text_t &collection, 
			       const text_t &OID, const text_t &metadataPrefix) = 0;
  virtual bool output_content(ostream &output, recptproto *protocol, oaiargs &params);
  virtual void output_content_for_all(ostream &output, recptproto *protocol, oaiargs &params);
  virtual void output_content_for_col(ostream &output, recptproto *protocol, text_t &gsdlCollect, 
				      ColInfoResponse_t &cinfo, comerror_t &err, oaiargs &params);
  virtual void recurse_set(ostream &output, recptproto *protocol, const text_t &collection, 
			   const text_t &classifier, oaiargs &params);
 protected:
  bool prevDocSeen;
  int  outputDocs;
  ResumptionToken *replyToken;
  bool check_classifier(recptproto *protocol, const text_t &collection, const text_t &classifier);
};
#endif
